︠5508eef1-3698-48a6-b236-11ec38af34c5︠
def LRAM(f, width, start, end):
    return width*sum(f(x) for x in [start..end-width,step=width])
def RRAM(f, width, start, end):
    return width*sum(f(x) for x in [start+width..end,step=width])
︡f8d7e62d-2df4-4b9b-b621-ac93d00fdb2a︡︡
︠665330ef-7b80-4c01-bbb2-4eeaea59f7f5︠
def f(x): return 1/e^x
width= 1/8
start=0
end=4
︡0abbfe98-d78e-446a-9e2b-44b85bf8ad21︡︡
︠df0b39c0-e2d4-4e8f-a84c-f5496c2378c0︠
LRAM(f,width,start,end)
︡d4a72d78-d90d-45c5-963a-a5783ae5d90b︡︡
︠6299aa7b-03b2-480a-9f4d-8a43f55a1c44︠
RRAM(f,width,start,end)
︡8f4ddee2-69fa-44cf-8cb5-e20ab9ba373c︡︡
︠5168d6db-c8a2-48a1-8e68-aa74863efb4b︠
def LRAMarea(f,width,start,end):
    L=[[start,0],[start,f(start)],[start+width,f(start)],[start+width,0]]
    if start+width==end: return polygon(L)
    return polygon(L) + LRAMarea(f,width,start+width,end)
    
def RRAMarea(f,width,start,end):
    L=[[start,0],[start,f(start+width)],[start+width,f(start+width)],[start+width,0]]
    if start+width==end: return polygon(L)
    return polygon(L) + RRAMarea(f,width,start+width,end)
︡77a405bd-b179-4834-959d-54a5a3ff640f︡︡
︠8ba5bfbf-61d6-447e-bccc-edc76cd6d593︠
LRAMarea(f,width,start,end)+plot(f,(x,start,end), color='red')
︡6d5357d8-53e4-4494-b6fa-64944d36747c︡︡
︠030b7aa6-2956-4777-815a-b58f428dfb59︠
RRAMarea(f,width,start,end)+plot(f,(x,start,end), color='red')
︡cf5a2830-4131-4b65-95c2-3e73272a13c8︡︡
︠365f2778-9915-4bad-9a14-8a866c8df781︠
f(x) = sin(x)

@interact
def _(width=pi/12,start=0,end=pi,RAM=['None','Left','Right']):
    show(f)
    graph = plot(f,(x,start,end), color='red')
    if RAM == 'Left': 
        graph += LRAMarea(f,width,start,end)
        print 'Approximate area:',LRAM(f,width,start,end).n()
    elif RAM == 'Right': 
        graph += RRAMarea(f,width,start,end)
        print 'Approximate area:',RRAM(f,width,start,end).n()
    if RAM != 'None': print 'Actual area:',integral(f,x,start,end).n()
    show(graph,aspect_ratio=1)
︡ed99752a-d5f2-4f8e-83ef-599b00301a52︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-23\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">width&nbsp;</font></td><td><input type=\"text\" value=\"1/12*pi\" size=80 onchange=\"interact(23, {variable: 'width', adapt_number: 9, value: encode64(this.value)}, 1)\"></input></td>\n</tr><tr><td align=right><font color=\"black\">start&nbsp;</font></td><td><input type=\"text\" value=\"0\" size=80 onchange=\"interact(23, {variable: 'start', adapt_number: 10, value: encode64(this.value)}, 1)\"></input></td>\n</tr><tr><td align=right><font color=\"black\">end&nbsp;</font></td><td><input type=\"text\" value=\"pi\" size=80 onchange=\"interact(23, {variable: 'end', adapt_number: 11, value: encode64(this.value)}, 1)\"></input></td>\n</tr><tr><td align=right><font color=\"black\">RAM&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, {variable: 'RAM', adapt_number: 12, value: encode64(this.value)}, 1)\">None</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, {variable: 'RAM', adapt_number: 12, value: encode64(this.value)}, 1)\">Left</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, {variable: 'RAM', adapt_number: 12, value: encode64(this.value)}, 1)\">Right</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-23\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
